﻿namespace TestProject;

/// <summary>
/// 메인 페이지
/// </summary>
public partial class MainPage : ContentPage
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region 생성자 - MainPage()

    /// <summary>
    /// 생성자
    /// </summary>
    public MainPage()
    {
        InitializeComponent();

        this.flashSwitch.Toggled += flashSwitch_Toggled;
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Private

    #region 플래시 스위치 토글시 처리하기 - flashSwitch_Toggled(sender, e)

    /// <summary>
    /// 플래시 스위치 토글시 처리하기
    /// </summary>
    /// <param name="sender">이벤트 발생자</param>
    /// <param name="e">이벤트 인자</param>
    private async void flashSwitch_Toggled(object sender, ToggledEventArgs e)
    {
        try
        {
            if(e.Value)
            {
                await Flashlight.Default.TurnOnAsync();
            }
            else
            {
                await Flashlight.Default.TurnOffAsync();
            }
        }
        catch(FeatureNotSupportedException)
        {
            await DisplayAlert("ERROR", "해당 기능을 지원하지 않습니다.", "확인");
        }
        catch(PermissionException)
        {
            await DisplayAlert("ERROR", "해당 기능의 권한이 없습니다.", "확인");
        }
        catch(Exception)
        {
        }
    }

    #endregion
}